unsigned long temp_res;
unsigned int valor, ban, apuesta, ram,i, num, record;
unsigned short digit_no= 0, decena, unidad, x;

unsigned short mask(unsigned short n){
  switch (n) {
    case 0 : return 0x3F;
    case 1 : return 0x06;
    case 2 : return 0x5B;
    case 3 : return 0x4F;
    case 4 : return 0x66;
    case 5 : return 0x6D;
    case 6 : return 0x7D;
    case 7 : return 0x07;
    case 8 : return 0x7F;
    case 9 : return 0x6F;
    case 10 : return 0x31;
    case 11 : return 0x7D;
    default : return 0x7f;
  }
}
unsigned short convertidor_bit(unsigned short n){
  switch (n) {
    case 1 : return 0x01;
    case 2 : return 0x02;
    case 3 : return 0x04;
    case 4 : return 0x08;
    case 5 : return 0x10;
    default : return 0x1F;
  }
}

void main(){
  ANSEL  = 0x01;              // Configure AN2 pin as analog
  ANSELH = 0;                 // Configure other AN pins as digital I/O
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;

  TRISA  = 0xFF;              // PORTA is input
  TRISB  = 0;                 // PORTB is output
  TRISC  = 0;                 // PORTC is output
  TRISD  = 0;                 // PORTD is output
  PORTE = 0;                     // Turn off both displays
  TRISE = 0;                     // All port A pins are configured as outputsPORTD = 0;
//  PORTA = 255;
  PORTB = 0;
  PORTC = 0;                     // Turn off all display segments
  PORTD = 0;
  do {
     PORTC = 0x6D;
     PORTD = 0x3E;

     if (RA1_bit) {
        while(1){


          temp_res=ADC_Read(0);   // Get 10-bit results of AD conversion
          valor = (temp_res * 99) / 1023;
          PORTB = (temp_res * 255) / 1023;         // Send lower 8 bits to PORTD
          x = (char)valor % 10u;
          unidad = mask(x);  // Prepare mask for displaying ones
          x = (char)(valor / 10u) % 10u;
          decena = mask(x); // Prepare mask for displaying tens

          PORTC = unidad;            // Set mask for displaying ones on PORTD
          PORTD = decena;           // Set mask for displaying tens on PORTD
          Delay_ms(15);
        }
     }
     if (RA2_bit) {
        ram=0;
        num=4,record=0;
        while(1){
          if (RA1_bit){
             delay_ms(250);
             num=num+1;
             if(num>5)
                num=1;
          }
          if (RA2_bit){
             delay_ms(250);
             num=num-1;
             if(num<1)
                num=5;
          }
          if (RA3_bit){
             delay_ms(25);
             while(RA3_bit){
                 PORTB = convertidor_bit(ram);
                 delay_ms(1000);
                 if(num==ram){
                     record++;
                     PORTC=1;PORTD=1;
                     for(i=1;i<24;i++){
                        delay_ms(100);
                        PORTC=PORTC*2;
                        PORTD=PORTD*2;
                        if(PORTC*2==128){
                           //delay_ms(100);          //Retardo de 200 mseg
                           PORTC = 1;
                           PORTD = 1;
                        }

                     }
                     PORTC = mask(record);
                     delay_ms(2000);
                     PORTC = 0;
                 }
                 else
                     record=0;
                 ram=0;
             }
          }
          ram=ram+1;
          delay_ms(5);
          if(ram>5)
            ram=1;
          x = (char)num;
          PORTD = mask(x);  // Prepare mask for displaying ones
          x = (char)record;//aleat;
          PORTC = mask(x); // Prepare mask for displaying tens
          // = unidad;            // Set mask for displaying ones on PORTD
          // = decena;           // Set mask for displaying tens on PORTC

        }
     }
     Delay_ms(5);
  } while(1);
}
